Crypto++ 8.5 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
BLAKE2b Class Reference

The BLAKE2b cryptographic hash function. More...

Inheritance diagram for BLAKE2b:

## Public Types
typedef BLAKE2b_State | State
typedef BLAKE2b_ParameterBlock | ParameterBlock
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Public Member Functions
| BLAKE2b (bool treeMode=false, unsigned int digestSize=DIGESTSIZE)
| Construct a BLAKE2b hash. More...
| BLAKE2b (unsigned int digestSize)
| Construct a BLAKE2s hash. More...
| BLAKE2b (const byte *key, size_t keyLength, const byte *salt=NULL, size_t saltLength=0, const byte *personalization=NULL, size_t personalizationLength=0, bool treeMode=false, unsigned int digestSize=DIGESTSIZE)
| Construct a BLAKE2b hash. More...
std::string | AlgorithmName () const
| Retrieve the object's name. More...
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | Restart (const BLAKE2b_ParameterBlock &block, const word64 counter[2])
| Restart a hash with parameter block and counter. More...
void | SetTreeMode (bool mode)
| Set tree mode. More...
bool | GetTreeMode () const
| Get tree mode. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterfaceImpl< MessageAuthenticationCode, BLAKE2b_Info >
size_t | MinKeyLength () const
| The minimum key length used by the algorithm. More...
size_t | MaxKeyLength () const
| The maximum key length used by the algorithm. More...
size_t | DefaultKeyLength () const
| The default key length used by the algorithm. More...
size_t | GetValidKeyLength (size_t keylength) const
| Provides a valid key length for the algorithm. More...
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| The default IV requirements for the algorithm. More...
unsigned int | IVSize () const
| The initialization vector length for the algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const =0
| Returns default key length. More...
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static const char * | StaticAlgorithmName ()

## Static Public Attributes
static const int | DEFAULT_KEYLENGTH = BLAKE2b_Info::DEFAULT_KEYLENGTH
static const int | MIN_KEYLENGTH = BLAKE2b_Info::MIN_KEYLENGTH
static const int | MAX_KEYLENGTH = BLAKE2b_Info::MAX_KEYLENGTH
static const int | DIGESTSIZE = BLAKE2b_Info::DIGESTSIZE
static const int | BLOCKSIZE = BLAKE2b_Info::BLOCKSIZE
static const int | SALTSIZE = BLAKE2b_Info::SALTSIZE
static const int | PERSONALIZATIONSIZE = BLAKE2b_Info::PERSONALIZATIONSIZE

## Detailed Description

The BLAKE2b cryptographic hash function.

BLAKE2b can function as both a hash and keyed hash. If you want only the hash, then use the BLAKE2b constructor that accepts no parameters or digest size. If you want a keyed hash, then use the constructor that accpts the key as a parameter. Once a key and digest size are selected, its effectively immutable. The Restart() method that accepts a ParameterBlock does not allow you to change it.

See also
  Aumasson, Neves, Wilcox-O'Hearn and Winnerlein's BLAKE2: simpler, smaller, fast as MD5 (2013.01.29).

Since
  C++ since Crypto++ 5.6.4, SSE since Crypto++ 5.6.4, NEON since Crypto++ 6.0, Power8 since Crypto++ 8.0

Definition at line 344 of file blake2.h.

## Constructor & Destructor Documentation

## ◆ BLAKE2b() [1/3]

BLAKE2b::BLAKE2b | ( | bool | treeMode = `false`,
|  | unsigned int | digestSize = `DIGESTSIZE`
| ) |  |

Construct a BLAKE2b hash.

Parameters

  digestSize | the digest size, in bytes
  treeMode | flag indicating tree mode

Since
  Crypto++ 5.6.4

Definition at line 336 of file blake2.cpp.

## ◆ BLAKE2b() [2/3]

BLAKE2b::BLAKE2b | ( | unsigned int | digestSize | ) |

Construct a BLAKE2s hash.

Parameters

  digestSize | the digest size, in bytes

treeMode flag is set to false

Since
  Crypto++ 8.2

Definition at line 356 of file blake2.cpp.

## ◆ BLAKE2b() [3/3]

BLAKE2b::BLAKE2b | ( | const byte * | key,
|  | size_t | keyLength,
|  | const byte * | salt = `NULL`,
|  | size_t | saltLength = `0`,
|  | const byte * | personalization = `NULL`,
|  | size_t | personalizationLength = `0`,
|  | bool | treeMode = `false`,
|  | unsigned int | digestSize = `DIGESTSIZE`
| ) |  |

Construct a BLAKE2b hash.

Parameters

  key | a byte array used to key the cipher
  keyLength | the size of the byte array
  salt | a byte array used as salt
  saltLength | the size of the byte array
  personalization | a byte array used as personalization string
  personalizationLength | the size of the byte array
  treeMode | flag indicating tree mode
  digestSize | the digest size, in bytes

Since
  Crypto++ 5.6.4

Definition at line 382 of file blake2.cpp.

## Member Function Documentation

## ◆ AlgorithmName()

std::string BLAKE2b::AlgorithmName | ( |  | ) | const
| inline virtual

Retrieve the object's name.

Returns
  the object's algorithm name following RFC 7693

Object algorithm name follows the naming described in RFC 7693, The BLAKE2 Cryptographic Hash and Message Authentication Code (MAC). For example, "BLAKE2b-512" and "BLAKE2s-256".

Reimplemented from Algorithm.

Definition at line 394 of file blake2.h.

## ◆ BlockSize()

unsigned int BLAKE2b::BlockSize | ( |  | ) | const
| inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent block size called rate expressed as `r`.

Reimplemented from HashTransformation.

Definition at line 396 of file blake2.h.

## ◆ DigestSize()

unsigned int BLAKE2b::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 397 of file blake2.h.

## ◆ OptimalDataAlignment()

unsigned int BLAKE2b::OptimalDataAlignment | ( |  | ) | const
| virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 192 of file blake2.cpp.

## ◆ Update()

void BLAKE2b::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |
| virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 573 of file blake2.cpp.

## ◆ Restart() [1/2]

void BLAKE2b::Restart | ( |  | ) |
| virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 468 of file blake2.cpp.

## ◆ Restart() [2/2]

void BLAKE2b::Restart | ( | const BLAKE2b_ParameterBlock & | block,
|  | const word64 | counter[2]
| ) |  |

Restart a hash with parameter block and counter.

Parameters

  block | parameter block
  counter | counter array

Parameter block is persisted across calls to Restart().

Definition at line 505 of file blake2.cpp.

## ◆ SetTreeMode()

void BLAKE2b::SetTreeMode | ( | bool | mode | ) |
| inline

Set tree mode.

Parameters

  mode | the new tree mode

BLAKE2 has two finalization flags, called State::f[0] and State::f[1]. If `treeMode=false` (default), then State::f[1] is never set. If `treeMode=true`, then State::f[1] is set when State::f[0] is set. Tree mode is persisted across calls to Restart().

Definition at line 415 of file blake2.h.

## ◆ GetTreeMode()

bool BLAKE2b::GetTreeMode | ( |  | ) | const
| inline

Get tree mode.

Returns
  the current tree mode

Tree mode is persisted across calls to Restart().

Definition at line 420 of file blake2.h.

## ◆ TruncatedFinal()

void BLAKE2b::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 636 of file blake2.cpp.

## ◆ AlgorithmProvider()

std::string BLAKE2b::AlgorithmProvider | ( |  | ) | const
| virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

Definition at line 212 of file blake2.cpp.

The documentation for this class was generated from the following files:

- blake2.h
- blake2.cpp